#include "bmud.h"

GtkWidget *win;

#ifdef GNOME
void do_menu(){
	GnomeUIInfo filemenu[]={
		{GNOME_APP_UI_ITEM,N_("Connect..."), N_("Connect to a mud"),cbox, mud, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_NEW,0, 0, NULL},
		{GNOME_APP_UI_ITEM,N_("Disconnect"), N_("Disconnect from a mud"),disconnect, NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_CLOSE,0, 0, NULL},
		GNOMEUIINFO_SEPARATOR,
		{GNOME_APP_UI_ITEM,N_("Exit"), N_("Exit bmud"),gtk_main_quit, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_QUIT,0, 0, NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo optionmenu[]={
		{GNOME_APP_UI_ITEM,N_("Font..."),N_("Select the font"),show_fontsel,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0,0,NULL},
		{GNOME_APP_UI_ITEM,N_("Colors..."),N_("Change the colors"),show_colorm,NULL,NULL,GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0,0,NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo toolmenu[]={
		{GNOME_APP_UI_ITEM,N_("Equip..."), N_("Equipment Window"),show_eq, NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PROP,0, 0, NULL},
		{GNOME_APP_UI_ITEM,N_("Map..."), N_("the mud map"),show_map,NULL, NULL, GNOME_APP_PIXMAP_STOCK,GNOME_STOCK_MENU_PREF,0, 0, NULL},
		GNOMEUIINFO_END
		};

	GnomeUIInfo helpmenu[]={
		{GNOME_APP_UI_ITEM, N_("About..."), NULL, do_about, NULL, NULL, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT, 'h', (GdkModifierType) GDK_CONTROL_MASK, NULL},
		GNOMEUIINFO_END
		};
	                                                
	GnomeUIInfo mainmenu[] = {
		{GNOME_APP_UI_SUBTREE, N_("File"), NULL, 
		filemenu, NULL, NULL, (GnomeUIPixmapType) 0,  NULL, 
		'f', (GdkModifierType) GDK_CONTROL_MASK, NULL},

		GNOMEUIINFO_SUBTREE(N_("Options"),optionmenu),
		GNOMEUIINFO_SUBTREE(N_("Tools"),toolmenu),
		GNOMEUIINFO_SUBTREE(N_("Help"),helpmenu),
		GNOMEUIINFO_END
		};

	gnome_app_create_menus((GnomeApp*)mud->window, mainmenu);
	gtk_menu_item_right_justify(GTK_MENU_ITEM(mainmenu[3].widget));
	return;
	}
#else
void do_menu(){
	/* gtk menu here */
	}
	
#endif

